OGRE: Ogre::HardwarePixelBuffer Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::HardwarePixelBuffer Class Reference

Specialisation of HardwareBuffer for a pixel buffer. More...

`#include <OgreHardwarePixelBuffer.h>`

Inheritance diagram for Ogre::HardwarePixelBuffer:

[legend]
List of all members.

## Public Types

enum | Usage { HBU_STATIC = 1, HBU_DYNAMIC = 2, HBU_WRITE_ONLY = 4, HBU_DISCARDABLE = 8, HBU_STATIC_WRITE_ONLY = 5, HBU_DYNAMIC_WRITE_ONLY = 6, HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = 14 }
| Enums describing buffer usage; not mutually exclusive. More...
enum | LockOptions { HBL_NORMAL, HBL_DISCARD, HBL_READ_ONLY, HBL_NO_OVERWRITE }
| Locking options. More...

## Public Member Functions

| HardwarePixelBuffer (size_t mWidth, size_t mHeight, size_t mDepth, PixelFormat mFormat, HardwareBuffer::Usage usage, bool useSystemMemory, bool useShadowBuffer)
| Should be called by HardwareBufferManager.
| ~HardwarePixelBuffer ()
virtual const PixelBox & | lock (const Image::Box &lockBox, LockOptions options)
| Lock the buffer for (potentially) reading / writing.
virtual void * | lock (size_t offset, size_t length, LockOptions options)

Parameters:

  | offset | The byte offset from the start of the buffer to lock
  | length | The size of the area to lock, in bytes
  | options | Locking options

Returns:
  Pointer to the locked memory

const PixelBox & | getCurrentLock ()
| Get the current locked region.
virtual void | readData (size_t offset, size_t length, void *pDest)

Parameters:

  | offset | The byte offset from the start of the buffer to read
  | length | The size of the area to read, in bytes
  | pDest | The area of memory in which to place the data, must be large enough to accommodate the data!

virtual void | writeData (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false)

Parameters:

  | offset | The byte offset from the start of the buffer to start writing
  | length | The size of the data to write to, in bytes
  | pSource | The source of the data to be written
  | discardWholeBuffer | If true, this allows the driver to discard the entire buffer when writing, such that DMA stalls can be avoided; use if you can.

virtual void | blit (const HardwarePixelBufferSharedPtr &src, const Image::Box &srcBox, const Image::Box &dstBox)
| Copies a box from another PixelBuffer to a region of the this PixelBuffer.
void | blit (const HardwarePixelBufferSharedPtr &src)
| Convience function that blits the entire source pixel buffer to this buffer.
virtual void | blitFromMemory (const PixelBox &src, const Image::Box &dstBox)=0
| Copies a region from normal memory to a region of this pixelbuffer.
void | blitFromMemory (const PixelBox &src)
| Convience function that blits a pixelbox from memory to the entire buffer.
virtual void | blitToMemory (const Image::Box &srcBox, const PixelBox &dst)=0
| Copies a region of this pixelbuffer to normal memory.
void | blitToMemory (const PixelBox &dst)
| Convience function that blits this entire buffer to a pixelbox.
virtual RenderTexture * | getRenderTarget (size_t slice=0)
| Get a render target for this PixelBuffer, or a slice of it.
size_t | getWidth () const
| Gets the width of this buffer.
size_t | getHeight () const
| Gets the height of this buffer.
size_t | getDepth () const
| Gets the depth of this buffer.
PixelFormat | getFormat () const
| Gets the native pixel format of this buffer.
void * | lock (LockOptions options)
| Lock the entire buffer for (potentially) reading / writing.
virtual void | unlock (void)
| Releases the lock on this buffer.
virtual void | copyData (HardwareBuffer &srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false)
| Copy data from another buffer into this one.
virtual void | _updateFromShadow (void)
| Updates the real buffer from the shadow buffer, if required.
size_t | getSizeInBytes (void) const
| Returns the size of this buffer in bytes.
Usage | getUsage (void) const
| Returns the Usage flags with which this buffer was created.
bool | isSystemMemory (void) const
| Returns whether this buffer is held in system memory.
bool | hasShadowBuffer (void) const
| Returns whether this buffer has a system memory shadow for quicker reading.
bool | isLocked (void) const
| Returns whether or not this buffer is currently locked.
void | suppressHardwareUpdate (bool suppress)
| Pass true to suppress hardware upload of shadow buffer changes.

## Protected Member Functions

virtual PixelBox | lockImpl (const Image::Box lockBox, LockOptions options)=0
| Internal implementation of lock(), must be overridden in subclasses.
virtual void * | lockImpl (size_t offset, size_t length, LockOptions options)
| Internal implementation of lock(), do not OVERRIDE or CALL this for HardwarePixelBuffer implementations, but override the previous method.
virtual void | _clearSliceRTT (size_t zoffset)
| Notify TextureBuffer of destruction of render target.
virtual void | unlockImpl (void)=0
| Internal implementation of unlock().

## Protected Attributes

size_t | mWidth
size_t | mHeight
size_t | mDepth
size_t | mRowPitch
size_t | mSlicePitch
PixelFormat | mFormat
PixelBox | mCurrentLock
size_t | mSizeInBytes
Usage | mUsage
bool | mIsLocked
size_t | mLockStart
size_t | mLockSize
bool | mSystemMemory
bool | mUseShadowBuffer
HardwareBuffer * | mpShadowBuffer
bool | mShadowUpdated
bool | mSuppressHardwareUpdate

## Friends

class | RenderTexture

## Detailed Description

Specialisation of HardwareBuffer for a pixel buffer.

The HardwarePixelbuffer abstracts an 1D, 2D or 3D quantity of pixels stored by the rendering API. The buffer can be located on the card or in main memory depending on its usage. One mipmap level of a texture is an example of a HardwarePixelBuffer.

Definition at line 47 of file OgreHardwarePixelBuffer.h.

## Member Enumeration Documentation

enum Ogre::HardwareBuffer::LockOptions`[inherited]`

Locking options.

Enumeration values:

  HBL_NORMAL | Normal mode, ie allows read/write and contents are preserved.
  HBL_DISCARD | Discards the entire buffer while locking; this allows optimisation to be performed because synchronisation issues are relaxed. Only allowed on buffers created with the HBU_DYNAMIC flag.
  HBL_READ_ONLY | Lock the buffer for reading only. Not allowed in buffers which are created with HBU_WRITE_ONLY. Mandatory on statuc buffers, ie those created without the HBU_DYNAMIC flag.
  HBL_NO_OVERWRITE | As HBL_NORMAL, except the application guarantees not to overwrite any region of the buffer which has already been used in this frame, can allow some optimisation on some APIs.

Definition at line 115 of file OgreHardwareBuffer.h.

enum Ogre::HardwareBuffer::Usage`[inherited]`

Enums describing buffer usage; not mutually exclusive.

Enumeration values:

  HBU_STATIC | Static buffer which the application rarely modifies once created. Modifying the contents of this buffer will involve a performance hit.
  HBU_DYNAMIC | Indicates the application would like to modify this buffer with the CPU fairly often. Buffers created with this flag will typically end up in AGP memory rather than video memory.
  HBU_WRITE_ONLY | Indicates the application will never read the contents of the buffer back, it will only ever write data. Locking a buffer with this flag will ALWAYS return a pointer to new, blank memory rather than the memory associated with the contents of the buffer; this avoids DMA stalls because you can write to a new memory area while the previous one is being used.

  HBU_DISCARDABLE

  Indicates that the application will be refilling the contents of the buffer regularly (not just updating, but generating the contents from scratch), and therefore does not mind if the contents of the buffer are lost somehow and need to be recreated.

  This allows and additional level of optimisation on the buffer. This option only really makes sense when combined with HBU_DYNAMIC_WRITE_ONLY.

  HBU_STATIC_WRITE_ONLY | Combination of HBU_STATIC and HBU_WRITE_ONLY.
  HBU_DYNAMIC_WRITE_ONLY | Combination of HBU_DYNAMIC and HBU_WRITE_ONLY. If you use this, strongly consider using HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE instead if you update the entire contents of the buffer very regularly.
  HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE | Combination of HBU_DYNAMIC, HBU_WRITE_ONLY and HBU_DISCARDABLE.

Definition at line 73 of file OgreHardwareBuffer.h.

## Constructor & Destructor Documentation

Ogre::HardwarePixelBuffer::HardwarePixelBuffer | ( | size_t | mWidth,
|  | size_t | mHeight,
|  | size_t | mDepth,
|  | PixelFormat | mFormat,
|  | HardwareBuffer::Usage | usage,
|  | bool | useSystemMemory,
|  | bool | useShadowBuffer
| ) |

| Should be called by HardwareBufferManager.

Ogre::HardwarePixelBuffer::~HardwarePixelBuffer | ( |  | ) |

## Member Function Documentation

virtual void Ogre::HardwarePixelBuffer::_clearSliceRTT | ( | size_t | zoffset | ) | `[protected, virtual]`

| Notify TextureBuffer of destruction of render target. Called by RenderTexture when destroyed.

virtual void Ogre::HardwareBuffer::_updateFromShadow | ( | void |  | ) | `[virtual, inherited]`

| Updates the real buffer from the shadow buffer, if required. Definition at line 279 of file OgreHardwareBuffer.h.

void Ogre::HardwarePixelBuffer::blit | ( | const HardwarePixelBufferSharedPtr & | src | ) |

Convience function that blits the entire source pixel buffer to this buffer.

If source and destination dimensions don't match, scaling is done.

Parameters:

  | src | PixelBox containing the source pixels and format in memory

Note:
  Only call this function when the buffer is unlocked.

virtual void Ogre::HardwarePixelBuffer::blit | ( | const HardwarePixelBufferSharedPtr & | src,
|  | const Image::Box & | srcBox,
|  | const Image::Box & | dstBox
| ) | `[virtual]`

Copies a box from another PixelBuffer to a region of the this PixelBuffer.

Parameters:

  | dst | Source pixel buffer
  | srcBox | Image::Box describing the source region in src
  | dstBox | Image::Box describing the destination region in this buffer

Remarks:
  The source and destination regions dimensions don't have to match, in which case scaling is done. This scaling is generally done using a bilinear filter in hardware, but it is faster to pass the source image in the right dimensions.

Note:
  Only call this function when both buffers are unlocked.

void Ogre::HardwarePixelBuffer::blitFromMemory | ( | const PixelBox & | src | ) |

Convience function that blits a pixelbox from memory to the entire buffer.

The source image is scaled as needed.

Parameters:

  | src | PixelBox containing the source pixels and format in memory

Note:
  Only call this function when the buffer is unlocked.

Definition at line 143 of file OgreHardwarePixelBuffer.h.

virtual void Ogre::HardwarePixelBuffer::blitFromMemory | ( | const PixelBox & | src,
|  | const Image::Box & | dstBox
| ) | `[pure virtual]`

Copies a region from normal memory to a region of this pixelbuffer.

The source image can be in any pixel format supported by OGRE, and in any size.

Parameters:

  | src | PixelBox containing the source pixels and format in memory
  | dstBox | Image::Box describing the destination region in this buffer

Remarks:
  The source and destination regions dimensions don't have to match, in which case scaling is done. This scaling is generally done using a bilinear filter in hardware, but it is faster to pass the source image in the right dimensions.

Note:
  Only call this function when the buffer is unlocked.

void Ogre::HardwarePixelBuffer::blitToMemory | ( | const PixelBox & | dst | ) |

Convience function that blits this entire buffer to a pixelbox.

The image is scaled as needed.

Parameters:

  | src | PixelBox containing the source pixels and format in memory

Note:
  Only call this function when the buffer is unlocked.

Definition at line 162 of file OgreHardwarePixelBuffer.h.

virtual void Ogre::HardwarePixelBuffer::blitToMemory | ( | const Image::Box & | srcBox,
|  | const PixelBox & | dst
| ) | `[pure virtual]`

Copies a region of this pixelbuffer to normal memory.

Parameters:

  | srcBox | Image::Box describing the source region of this buffer
  | dst | PixelBox describing the destination pixels and format in memory

Remarks:
  The source and destination regions don't have to match, in which case scaling is done.

Note:
  Only call this function when the buffer is unlocked.

virtual void Ogre::HardwareBuffer::copyData | ( | HardwareBuffer & | srcBuffer,
|  | size_t | srcOffset,
|  | size_t | dstOffset,
|  | size_t | length,
|  | bool | discardWholeBuffer = `false`
| ) | `[virtual, inherited]`

Copy data from another buffer into this one.

Remarks:
  Note that the source buffer must not be created with the usage HBU_WRITE_ONLY otherwise this will fail.

Parameters:

  | srcBuffer | The buffer from which to read the copied data
  | srcOffset | Offset in the source buffer at which to start reading
  | dstOffset | Offset in the destination buffer to start writing
  | length | Length of the data to copy, in bytes.
  | discardWholeBuffer | If true, will discard the entire contents of this buffer before copying

Definition at line 269 of file OgreHardwareBuffer.h.

const PixelBox& Ogre::HardwarePixelBuffer::getCurrentLock | ( |  | ) |

Get the current locked region.

This is the same value as returned by lock(const Image::Box, LockOptions)

Returns:
  PixelBox containing the locked region

size_t Ogre::HardwarePixelBuffer::getDepth | ( |  | ) | const

| Gets the depth of this buffer. Definition at line 181 of file OgreHardwarePixelBuffer.h.

PixelFormat Ogre::HardwarePixelBuffer::getFormat | ( |  | ) | const

| Gets the native pixel format of this buffer. Definition at line 183 of file OgreHardwarePixelBuffer.h.

size_t Ogre::HardwarePixelBuffer::getHeight | ( |  | ) | const

| Gets the height of this buffer. Definition at line 179 of file OgreHardwarePixelBuffer.h.

virtual RenderTexture* Ogre::HardwarePixelBuffer::getRenderTarget | ( | size_t | slice = `0` | ) | `[virtual]`

Get a render target for this PixelBuffer, or a slice of it.

The texture this was acquired from must have TU_RENDERTARGET set, otherwise it is possible to render to it and this method will throw an ERR_RENDERSYSTEM exception.

Parameters:

  | slice | Which slice

Returns:
  A pointer to the render target. This pointer has the lifespan of this PixelBuffer.

size_t Ogre::HardwareBuffer::getSizeInBytes | ( | void |  | ) | const`[inherited]`

| Returns the size of this buffer in bytes. Definition at line 304 of file OgreHardwareBuffer.h.

Usage Ogre::HardwareBuffer::getUsage | ( | void |  | ) | const`[inherited]`

| Returns the Usage flags with which this buffer was created. Definition at line 306 of file OgreHardwareBuffer.h.

size_t Ogre::HardwarePixelBuffer::getWidth | ( |  | ) | const

| Gets the width of this buffer. Definition at line 177 of file OgreHardwarePixelBuffer.h.

bool Ogre::HardwareBuffer::hasShadowBuffer | ( | void |  | ) | const`[inherited]`

| Returns whether this buffer has a system memory shadow for quicker reading. Definition at line 310 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::isLocked | ( | void |  | ) | const`[inherited]`

| Returns whether or not this buffer is currently locked. Definition at line 312 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::isSystemMemory | ( | void |  | ) | const`[inherited]`

| Returns whether this buffer is held in system memory. Definition at line 308 of file OgreHardwareBuffer.h.

void* Ogre::HardwareBuffer::lock | ( | LockOptions | options | ) | `[inherited]`

Lock the entire buffer for (potentially) reading / writing.

Parameters:

  | options | Locking options

Returns:
  Pointer to the locked memory

Definition at line 205 of file OgreHardwareBuffer.h.

virtual void* Ogre::HardwarePixelBuffer::lock | ( | size_t | offset,
|  | size_t | length,
|  | LockOptions | options
| ) | `[virtual]`

Parameters:

  | offset | The byte offset from the start of the buffer to lock
  | length | The size of the area to lock, in bytes
  | options | Locking options

Returns:
  Pointer to the locked memory

Reimplemented from Ogre::HardwareBuffer.

virtual const PixelBox& Ogre::HardwarePixelBuffer::lock | ( | const Image::Box & | lockBox,
|  | LockOptions | options
| ) | `[virtual]`

Lock the buffer for (potentially) reading / writing.

Parameters:

  | lockBox | Region of the buffer to lock
  | options | Locking options

Returns:
  PixelBox containing the locked region, the pitches and the pixel format

virtual void* Ogre::HardwarePixelBuffer::lockImpl | ( | size_t | offset,
|  | size_t | length,
|  | LockOptions | options
| ) | `[protected, virtual]`

| Internal implementation of lock(), do not OVERRIDE or CALL this for HardwarePixelBuffer implementations, but override the previous method. Implements Ogre::HardwareBuffer.

virtual PixelBox Ogre::HardwarePixelBuffer::lockImpl | ( | const Image::Box | lockBox,
|  | LockOptions | options
| ) | `[protected, pure virtual]`

| Internal implementation of lock(), must be overridden in subclasses.

virtual void Ogre::HardwarePixelBuffer::readData | ( | size_t | offset,
|  | size_t | length,
|  | void * | pDest
| ) | `[virtual]`

Parameters:

  | offset | The byte offset from the start of the buffer to read
  | length | The size of the area to read, in bytes
  | pDest | The area of memory in which to place the data, must be large enough to accommodate the data!

Implements Ogre::HardwareBuffer.

void Ogre::HardwareBuffer::suppressHardwareUpdate | ( | bool | suppress | ) | `[inherited]`

| Pass true to suppress hardware upload of shadow buffer changes. Definition at line 316 of file OgreHardwareBuffer.h.

virtual void Ogre::HardwareBuffer::unlock | ( | void |  | ) | `[virtual, inherited]`

Releases the lock on this buffer.

Remarks:
  Locking and unlocking a buffer can, in some rare circumstances such as switching video modes whilst the buffer is locked, corrupt the contents of a buffer. This is pretty rare, but if it occurs, this method will throw an exception, meaning you must re-upload the data.

  Note that using the 'read' and 'write' forms of updating the buffer does not suffer from this problem, so if you want to be 100% sure your data will not be lost, use the 'read' and 'write' forms instead.

Reimplemented in Ogre::DefaultHardwareVertexBuffer, and Ogre::DefaultHardwareIndexBuffer.

Definition at line 221 of file OgreHardwareBuffer.h.

virtual void Ogre::HardwareBuffer::unlockImpl | ( | void |  | ) | `[protected, pure virtual, inherited]`

| Internal implementation of unlock(). Implemented in Ogre::DefaultHardwareVertexBuffer, and Ogre::DefaultHardwareIndexBuffer.

virtual void Ogre::HardwarePixelBuffer::writeData | ( | size_t | offset,
|  | size_t | length,
|  | const void * | pSource,
|  | bool | discardWholeBuffer = `false`
| ) | `[virtual]`

Parameters:

  | offset | The byte offset from the start of the buffer to start writing
  | length | The size of the data to write to, in bytes
  | pSource | The source of the data to be written
  | discardWholeBuffer | If true, this allows the driver to discard the entire buffer when writing, such that DMA stalls can be avoided; use if you can.

Implements Ogre::HardwareBuffer.

## Friends And Related Function Documentation

friend class RenderTexture`[friend]`

| Definition at line 73 of file OgreHardwarePixelBuffer.h.

## Member Data Documentation

PixelBox Ogre::HardwarePixelBuffer::mCurrentLock`[protected]`

| Definition at line 57 of file OgreHardwarePixelBuffer.h.

size_t Ogre::HardwarePixelBuffer::mDepth`[protected]`

| Definition at line 51 of file OgreHardwarePixelBuffer.h.

PixelFormat Ogre::HardwarePixelBuffer::mFormat`[protected]`

| Definition at line 55 of file OgreHardwarePixelBuffer.h.

size_t Ogre::HardwarePixelBuffer::mHeight`[protected]`

| Definition at line 51 of file OgreHardwarePixelBuffer.h.

bool Ogre::HardwareBuffer::mIsLocked`[protected, inherited]`

| Definition at line 137 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareBuffer::mLockSize`[protected, inherited]`

| Definition at line 139 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareBuffer::mLockStart`[protected, inherited]`

| Definition at line 138 of file OgreHardwareBuffer.h.

HardwareBuffer* Ogre::HardwareBuffer::mpShadowBuffer`[protected, inherited]`

| Definition at line 142 of file OgreHardwareBuffer.h.

size_t Ogre::HardwarePixelBuffer::mRowPitch`[protected]`

| Definition at line 53 of file OgreHardwarePixelBuffer.h.

bool Ogre::HardwareBuffer::mShadowUpdated`[protected, inherited]`

| Definition at line 143 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareBuffer::mSizeInBytes`[protected, inherited]`

| Definition at line 135 of file OgreHardwareBuffer.h.

size_t Ogre::HardwarePixelBuffer::mSlicePitch`[protected]`

| Definition at line 53 of file OgreHardwarePixelBuffer.h.

bool Ogre::HardwareBuffer::mSuppressHardwareUpdate`[protected, inherited]`

| Definition at line 144 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mSystemMemory`[protected, inherited]`

| Definition at line 140 of file OgreHardwareBuffer.h.

Usage Ogre::HardwareBuffer::mUsage`[protected, inherited]`

| Definition at line 136 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mUseShadowBuffer`[protected, inherited]`

| Definition at line 141 of file OgreHardwareBuffer.h.

size_t Ogre::HardwarePixelBuffer::mWidth`[protected]`

| Definition at line 51 of file OgreHardwarePixelBuffer.h.

The documentation for this class was generated from the following file:

- OgreHardwarePixelBuffer.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:46:51 2008